clear();

KANTE = 1;


function f = rechteSeite(t,y)
    //003:
    MINBETA = 0.00001;  //Grenze zum Umschalten des Modells für Geradeausfahrt
    
    //Tests:
    //MINBETA = 0.0001;  //O.K.
    //MINBETA = 0.001;  //O.K.
    //MINBETA = 0.01;  //NICHT O.K.

    //004:
    //Geschwindigkeitsabhängige Dämpfungskraft FD einbauen.
    Drad = 1.0; //Dämpfung ... Rollreibung, Luftwiderstand usw.


    q = 0.1;
    r = 0.1;
    m = 1.0;
    quad_lang = 0.2;
    quad_breit = 0.1;
    J = m*(quad_breit*quad_breit + quad_lang*quad_lang)/12;




    FA   = 0.1;

    xs   = y(1,1);
    ys   = y(2,1);
    phi  = y(3,1);

    vx  = y(4,1);
    vy  = y(5,1);
    om  = y(6,1);   

    //wird durch Integration als 7. Zustandsgröße gewonnen:
    bbeta = y(7,1);

    SP = sin(phi);
    CP = cos(phi);
    SB = sin(bbeta);
    CB = cos(bbeta);
    SPB = sin(phi+bbeta);
    CPB = cos(phi+bbeta);

    //  ******************** BODENSENSOR  *****************************
    //Bodensensor:
    //Es wird angenommen, dass am Boden ein schwarzes Quadrat 
    //der Kantenlänge 1m liegt, Ursprung linke untere Ecke 0/0.

    //KANTE = 1;  //global s.o.

    //Der Sensor ist ein Strich parallel zur Hinterachse durch den Schwerpunkt.
    //Der Sensorwert ist der Anteil, den der Strich im schwarzen Quadrat liegt.

    //1) Wie weit liegt der Schnittpunkt der "Sensorgeraden" mit dem Rand des 
    //   schwarzen Quadrates vom Schwerpunkt weg?

    STRICHRADIUS = 0.3;

    BODENSENSOR = 1000; //Default kein Wert    
    Bunten  = 1000;  //aufgrund der Schnittpunkte mit den einzelnen Randgeraden des Quadrates
    Boben   = 1000;
    Blinks  = 1000;
    Brechts = 1000;

    phiphi = phi;
    while(phiphi>2*%pi)  //Begrenzen auf 0..2pi
        phiphi = phiphi-2*%pi;
    end
    while(phiphi<0)  //Begrenzen auf 0..2pi
        phiphi = phiphi+2*%pi;
    end

    //Mitte: 0
    //if (  (phiphi>1.5*%pi) | (phiphi<%pi/2) ) then 
    if (  abs(CP)>0 & xs<KANTE ) then 
        //[xs;ys]+Bunten*[-sin phi;cos phi] = [x;0]
        // ys + Bunten*cos phi = 0
        Bunten = -ys/CP;
    end


    //Mitte: 1.5pi
    //if (  (phiphi<2.0*%pi) & (phiphi>%pi) ) then 
    if (  abs(SP)>0 & ys<KANTE ) then 
        //[xs;ys]+Blinks*[-sin phi;cos phi] = [0;y]
        // xs - Blinks*sin phi = 0
        Blinks = xs/SP;
    end

    //Mitte: pi
    //if (  (phiphi>0.5*%pi) | (phiphi<1.5*%pi) ) then 
    if (  abs(CP)>0 & xs>0 ) then 
        //[xs;ys]+Boben*[-sin phi;cos phi] = [x;KANTE]
        // ys + Boben*cos phi = KANTE
        Boben = (KANTE-ys)/CP;
    end

    //Mitte: 0.5pi
    //if (  (phiphi<%pi) & (phiphi>0) ) then 
    if (  abs(SP)>0 & ys>0 ) then 
        //[xs;ys]+Brechts*[-sin phi;cos phi] = [KANTE;y]
        // xs - Brechts*sin phi = KANTE
        Brechts = (xs-KANTE)/SP;
    end

    if(  abs(Bunten)<abs(BODENSENSOR) ) then 
        BODENSENSOR = Bunten;
    end
    if(  abs(Boben)<abs(BODENSENSOR) ) then 
        BODENSENSOR = Boben;
    end
    if(  abs(Blinks)<abs(BODENSENSOR) ) then 
        BODENSENSOR = Blinks;
    end
    if(  abs(Brechts)<abs(BODENSENSOR) ) then 
        BODENSENSOR = Brechts;
    end


    if (abs(BODENSENSOR)>STRICHRADIUS) then //wenn ausserhalb Sensorbereich, einfach gerade stellen
        Dbbeta = -0.001*bbeta;
    else
        Dbbeta = 15*BODENSENSOR;
    end



    if (  (bbeta>0.3*%pi) & (Dbbeta>0) ) then
         Dbbeta = 0.0;
    end
    if (  (bbeta<-0.3*%pi) & (Dbbeta<0) ) then
         Dbbeta = 0.0;
    end

    //  ******************** ENDE BODENSENSOR  *****************************



    //********************** DÄMPFUNG ****************************
    //Richtung und Geschwindigkeit des Rades berechnen, um FD bilden zu können:

    //1. Position des Radmittelpunktes:
    x_rad = xs + CP*r;
    y_rad = ys + SP*r;

    //2. Richtung des Rades (ex)
    dir_x_rad = CPB;
    dir_y_rad = SPB;

    //3. Aktuelle Geschwindigkeit des Radmittelpunktes:
    vx_rad = vx - om*SP*r;
    vy_rad = vy + om*CP*r;

    //4. Skalar der Radgeschwindigkeit in Radrichtung ex*vrad
    v_rad = dir_x_rad*vx_rad + dir_y_rad*vy_rad;

    //5. Berechnung der Dämpfungskraft und Hinzunahme zur Antriebskraft:
    FD = -Drad*v_rad;
    FA = FA+FD;
    //********************** ENDE DÄMPFUNG ****************************

    //Zwangskräfte berechnen
    if abs(bbeta)>MINBETA then
        //Momentanpol:
        b = (r+q)/(SPB*CP-CPB*SP);
        xP = xs + r*CP - b*SPB;
        yP = ys + r*SP + b*CPB;
        QQ = (om+Dbbeta)*CPB*CP-om*SPB*SP;
        RR = (om+Dbbeta)*SPB*SP - om*CPB*CP;
        Db = -(r+q)* ( (SPB*CP-CPB*SP)^(-2) ) * (QQ+RR);//Zeitliche Ableitung: vorangestelltes D!
        DxP = vx - r*om*SP-Db*SPB-b*(om+Dbbeta)*CPB;
        DyP = vy + r*om*CP+Db*CPB-b*(om+Dbbeta)*SPB;


        //Herleitung:
        //  DDx = (FHx + FVx + FAx)/m;
        //  DDy = (FHy + FVy + FAy)/m;
        //  -DDphi*(y-yP)*m-om*(vy-DyP)*m = -FH*SP - FV*SPB + FA*CPB;
        //   DDphi*(x-xP)*m+om*(vx-DxP)*m =  FH*CP + FV*CPB + FA*SPB;

        //   DDphi = (-q*FH+r*FV*(CP*CPB+SP*SPB)+r*FA*(CP*SPB-SP*CPB))/J
        EEE = q/J;
        FFF = r*(CP*CPB+SP*SPB)/J;
        GGG = r*(CP*SPB-SP*CPB)/J;
        //   DDphi = -EEE*FH + FFF*FV + GGG*FA
        HHH =  om*(vy-DyP)*m;
        III =  om*(vx-DxP)*m;
        JJJ =  (ys - yP)*m;
        KKK =  (xs - xP)*m;
        //  -DDphi*JJJ-HHH = -FH*SP - FV*SPB + FA*CPB;
        //   DDphi*KKK+III =  FH*CP + FV*CPB + FA*SPB;
        //
        //  -(-EEE*FH + FFF*FV + GGG*FA)*JJJ-HHH = -FH*SP - FV*SPB + FA*CPB;
        //   (-EEE*FH + FFF*FV + GGG*FA)*KKK+III =  FH*CP + FV*CPB + FA*SPB;
        //
        //     EEE*JJJ*FH - FFF*JJJ*FV - GGG*JJJ*FA - HHH = -FH*SP - FV*SPB + FA*CPB;
        //    -EEE*KKK*FH + FFF*KKK*FV + GGG*KKK*FA + III =  FH*CP + FV*CPB + FA*SPB;
        //     EEE*JJJ*FH + FH*SP - FFF*JJJ*FV + FV*SPB   =   + FA*CPB + GGG*JJJ*FA + HHH;
        //    -EEE*KKK*FH - FH*CP + FFF*KKK*FV - FV*CPB   =   + FA*SPB - GGG*KKK*FA - III;

        // AA * [FH;FV] = bb

        AA = [ EEE*JJJ + SP , - FFF*JJJ + SPB;
              -EEE*KKK - CP ,   FFF*KKK - CPB ];

        bb = [FA*CPB + GGG*JJJ*FA + HHH ; FA*SPB - GGG*KKK*FA - III ];

        FHFV = inv(AA)*bb;

        FH   = FHFV(1);
        FV   = FHFV(2);

        FHx = -FH*SP;
        FHy =  FH*CP;
        FVx = -FV*SPB;
        FVy =  FV*CPB;
    else
        //Wenn Geradeausfahrt
        FH   = 0;
        FV   = 0;

        FHx = 0;
        FHy = 0;
        FVx = 0;
        FVy = 0;
    end
    //Ende Zwangskräfte berechnen

    FAx = FA*CPB;
    FAy = FA*SPB;

    f(1,1) = vx;
    f(2,1) = vy;
    f(3,1) = om;

    f(4,1) = (FHx + FVx + FAx)/m;
    f(5,1) = (FHy + FVy + FAy)/m;
    f(6,1) = (-q*FH+r*FV*(CP*CPB+SP*SPB)+r*FA*(CP*SPB-SP*CPB))/J;
    f(7,1) = Dbbeta; //so wird aus der Winkelgeschw. des Lenkwinkels dieser integriert.
endfunction

t = linspace(0,100,10000);
y0 = [0,-0.05,0,0,0,0,0]'; //7. Zustand: Lenkwinkel
//y0 = [KANTE+0.05,0,0.5*%pi,0,0,0,0]'; //7. Zustand: Lenkwinkel
t0 = 0;
y  = ode("rkf",y0,t0,t,rechteSeite);

//Quadrat einzeichnen:
plot([0,KANTE],[0,0],'gre');
plot([0,KANTE],[KANTE,KANTE],'gre');
plot([0,0.0001],[0,KANTE],'gre');
plot([KANTE,KANTE+0.0001],[0,KANTE],'gre');

plot(y(1,:)',y(2,:)');
a = gca();
a.x_label.text = 'xs/m';
a.y_label.text = 'ys/m';
a.title.text = 'Fahrtverlauf ys gegen xs';



//Geschwindigkeit in x-Richtung anzeigen:
//plot(t,y(4,:)');
//a = gca();
//a.x_label.text = 't/s';
//a.y_label.text = 'vx/ m/s';
//a.title.text = 'Geschwindigkeitsverlauf Geradeausfahrt mit Dämpfung';
